// HaloMap.h

#pragma once

#include "MapHeaderInfo.h"
#include "MapIndexHeaderInfo.h"
#include "MapObjectInfo.h"

using namespace System;
using namespace System::IO;

namespace HaloMap {

	public ref class Map  
	{

	#pragma region Constructor

	public: Map(String^ filePath)
			{
				FilePath = filePath;
				FileStream^ fs = gcnew System::IO::FileStream(FilePath,FileMode::OpenOrCreate,FileAccess::ReadWrite,FileShare::ReadWrite);
				BinaryReader^ br = gcnew System::IO::BinaryReader(fs);
				Header = gcnew HaloMap::MapHeaderInfo(br);
				Index = gcnew HaloMap::MapIndexHeaderInfo(br, PrimaryMagic, SecondaryMagic, Header->IndexOffset, Header->MetaStart);
				Objects = gcnew HaloMap::MapObjectInfo(br, Index->TagsOffset, Index->MetaCount, SecondaryMagic, Header->FileTableOffset);
			}

	#pragma endregion

	#pragma region Fields

	public:
		String^ FilePath;
		int PrimaryMagic;
		int SecondaryMagic;
		HaloMap::MapHeaderInfo^ Header;
		HaloMap::MapIndexHeaderInfo^ Index;
		HaloMap::MapObjectInfo^ Objects;

	#pragma endregion

	};
}
