// MapHeaderInfo.h

#pragma once

using namespace System;
using namespace System::IO;

namespace HaloMap {

	public ref class MapHeaderInfo  
	{

	#pragma region Constructor

	public: MapHeaderInfo(BinaryReader^ br)
			{
				br->BaseStream->Position = 8;
				FileSize = br->ReadInt32();
				br->BaseStream->Position = 16;
				IndexOffset = br->ReadInt32();
				MetaStart = br->ReadInt32();
				MetaSize = br->ReadInt32();
				CombinedSize = br->ReadInt32();

				br->BaseStream->Position = 340;
				CrazySize = br->ReadInt32();
				CrazyOffset = br->ReadInt32();

				br->BaseStream->Position += 4;
				ScriptReferenceOffset = br->ReadInt32();
				ScriptCount = br->ReadInt32();
				ScriptReferenceSize = br->ReadInt32();
				ScriptReferenceIndex = br->ReadInt32();
				ScriptReferenceStrings = br->ReadInt32();

				br->BaseStream->Position = 704;
				FileCount = br->ReadInt32();
				FileTableOffset = br->ReadInt32();
				FileTableSize = br->ReadInt32();
				FileIndex = br->ReadInt32();

				Signature = br->ReadInt32();
			}

#pragma endregion

	#pragma region Fields

	public:
		int FileSize;
		int IndexOffset;
		int MetaStart;
		int MetaSize;
		int CombinedSize;

		int CrazySize;
		int CrazyOffset;

		int ScriptReferenceOffset;
		int ScriptCount;
		int ScriptReferenceSize;
		int ScriptReferenceIndex;
		int ScriptReferenceStrings;

		int FileCount;
		int FileTableOffset;
		int FileTableSize;
		int FileIndex;

		int Signature;

#pragma endregion

	};
}