// MapIndexHeaderInfo.h

#pragma once

#include "Map.h"

using namespace System;
using namespace System::IO;

namespace HaloMap {

	public ref class MapIndexHeaderInfo  
	{

	#pragma region Constructor

	public: MapIndexHeaderInfo(BinaryReader^ br, int primaryMagic, int secondaryMagic, int indexOffset, int metaStart)
			{
				br->BaseStream->Position = indexOffset;
				ConstantMagic = br->ReadInt32();
				primaryMagic = ConstantMagic - (indexOffset + 32);
				TagClassCount = br->ReadInt32();
				TagsOffset = br->ReadInt32() - primaryMagic;
				ScenarioID = br->ReadInt32();
				TagIDStart = br->ReadInt32();
				br->BaseStream->Position += 4;
				MetaCount = br->ReadInt32();

				br->BaseStream->Position = TagsOffset + 8;
				secondaryMagic = br->ReadInt32() - (indexOffset + metaStart);
			}

	#pragma endregion

	#pragma region Fields

	public:
		int ConstantMagic;
		int TagClassCount;
		int TagsOffset;
		int ScenarioID;
		int TagIDStart;
		int MetaCount;

	#pragma endregion

	};
}