// MapObjectInfo.h

#pragma once

using namespace System;
using namespace System::IO;

namespace HaloMap {

	public ref class MapObjectInfo  
	{

	#pragma region Constructor

	public: MapObjectInfo(BinaryReader^ br, int tagsOffset, int metaCount, int secondaryMagic, int fileTableOffset)
			{
				br->BaseStream->Position = tagsOffset;
				Identifier = gcnew array<int>(metaCount);
				Offset = gcnew array<int>(metaCount);
				Size = gcnew array<int>(metaCount);
				Class = gcnew array<String^>(metaCount);
				Name = gcnew array<String^>(metaCount);

				for (int x = 0; x < metaCount; x++){
					Class[x] = ReverseString(br->ReadChars(4));
					Identifier[x] = br->ReadInt32();
					Offset[x] = br->ReadInt32();
					Size[x] = br->ReadInt32();
				}

				br->BaseStream->Position = fileTableOffset;
				for (int x = 0; x < metaCount; x++){
					wchar_t^ databit = br->ReadChar();
					while (Convert::ToByte(databit) != 0){
						Name[x] += databit;
						databit = br->ReadChar();
					}
				}

			}

	#pragma endregion

	#pragma region Fields

	public:
		array<int>^ Identifier;
		array<int>^ Offset;
		array<int>^ Size;
		array<String^>^ Class;
		array<String^>^ Name;

#pragma endregion

	#pragma region Methods

		String^ ReverseString(array<wchar_t>^ chars){
			String^ final = "";
			for(int i = 1; i <= chars->Length; i++)
			{
			  final += chars[chars->Length - i];
			}
			 return final;
		}

	#pragma endregion

	};
}